package edu.tuwien.kbs.db;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import sun.reflect.generics.reflectiveObjects.NotImplementedException;



public abstract class StoreConnectionBase implements IStoreConnection {

	protected  String			driverClassName;
	
	protected String host;
	protected String db;
	protected String user;
	protected String password;
	protected Connection connection;

	public StoreConnectionBase() {
		super();
	}

	public StoreConnectionBase(String host, String db, String user, String password) {

		if( host == null ) host = "localhost";
		
		this.host = host;
		this.db = db;
		this.user = user;
		this.password = password;
	
		
	}

	/**
	 * Open the SQL connection of a store
	 */
	public void connect() {
	    throw new NotImplementedException();
	}
	
	public void connect(int transactionIsolation) {
	    throw new NotImplementedException();
	}

	
	/**
	 * Close the SQL connection of a store
	 */
	public void close() {
		try {
			if( connection != null )
				connection.close();
		} catch( SQLException e ) {
			//log.error( "Error on closing connection: " + getUrl() );
			throw new RuntimeException( e );
		}
	}
	
	/**
	 * Execute a SQL statement
	 */
	public void executeStatement(String sql) {
		try {
			Statement stmt = connection.createStatement();
			stmt.execute( sql );
			stmt.close();
		} catch( SQLException e ) {
			throw new RuntimeException( e );
		}
	}
	
	/**
	 * Prepare a SQL statement
	 */	
	public PreparedStatement prepareStatement(String sql) {
		try {
			return connection.prepareStatement( sql );
		} catch( SQLException e ) {
			throw new RuntimeException( e );
		}
	}
	
	/**
	 * Create and return a SQL statement
	 */
	public Statement createStatement() {
		try {
			return connection.createStatement();
		} catch( SQLException e ) {
			throw new RuntimeException( e );
		}
	}
	
	public Statement createScrollStatement() {
		try {
			return connection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
		} catch( SQLException e ) {
			throw new RuntimeException( e );
		}
	}
	
	
	
	/**
	 * Clear a SQL table
	 */
	
	public void deleteTable(String predicate) {
	
    	String sql = "DELETE FROM " + predicate + ";";
    	
 		try {
			
        	this.executeStatement(sql);	

		} catch( Exception e ) {
			throw new RuntimeException( e );
		}
		
	}
	


}