package edu.tuwien.kbs.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import sun.reflect.generics.reflectiveObjects.NotImplementedException;


public class StoreConnectionPostgreSQL extends StoreConnectionBase { 

	protected String driverClassName;
	protected String url;
	
	public StoreConnectionPostgreSQL(String host, String db, String user, String password) {
		super( host, db, user, password );

		this.url = "jdbc:postgresql://" + this.host + "/" + this.db;
		this.driverClassName = "org.postgresql.Driver";
		
	}

	public void connect(int transactionIsolation) {
		try {
			Class.forName( getDriverClassName() );
			connection = DriverManager.getConnection( url, user, password );
			// connection.setAutoCommit(false);
			connection.setTransactionIsolation(transactionIsolation); // TRANSACTION_SERIALIZABLE

		} catch( SQLException e ) {
			//log.error( "Error on connecting to database: " + url + ", " + user + ", " + password );
			throw new RuntimeException( e );
		} catch( ClassNotFoundException e ) {
			//log.error( "Please set the required driver to the classpath: " + url );
			throw new RuntimeException( e );
		}
	    
	}
	

	public void connect() {
		try {
			Class.forName( getDriverClassName() );
			connection = DriverManager.getConnection( url, user, password );

		} catch( SQLException e ) {
			//log.error( "Error on connecting to database: " + url + ", " + user + ", " + password );
			throw new RuntimeException( e );
		} catch( ClassNotFoundException e ) {
			//log.error( "Please set the required driver to the classpath: " + url );
			throw new RuntimeException( e );
		}
	}
	
	public String getUrl() {
		return url;
	}

	public String getDriverClassName() {
		return driverClassName;
	}



}
