package edu.tuwien.kbs.geo;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.GeometryFactory;
import com.vividsolutions.jts.geom.PrecisionModel;

import edu.tuwien.kbs.routing.*;
import edu.tuwien.kbs.util.Util;


public class SimpleGMLReader {

    public static PrecisionModel precisionModel = new PrecisionModel(
	    PrecisionModel.FLOATING);
    public static GeometryFactory GeomFactory = new GeometryFactory(
	    precisionModel);
    
    protected static String encoding = "UTF-8";
    protected static String GML_LineString = "gml:LineString";
    protected static String GML_Coordinates = "coordinates"; //gml:
    protected static String GML_Namespace = "http://www.opengis.net/gml";
    
    protected static String RoutesFileName = "data/route_02.gml"; // route_02.gml
    protected static String ViaRoutesFileName1 = "data/viaroute_01.gml";
    protected static String ViaRoutesFileName2 = "data/viaroute_02.gml";
       
    
    public SimpleGMLReader() {

    }

    public ArrayList<Route> loadViaAITRoutes() {
	
	BufferedReader reader = null;
	ArrayList<Route> routes = new ArrayList<Route>();
	
	try {
	    // Route 1
	    reader = new BufferedReader(new InputStreamReader(new FileInputStream(ViaRoutesFileName1), encoding));
	    StringBuffer xml = new StringBuffer();
	    
	    for (String line; (line = reader.readLine()) != null;) 
		    xml.append(line);		
	    
	    if(xml.length() > 0) {
		RouteVia route = new RouteVia();
		route.fillDetails(xml.toString(), null, null);
		routes.add(route);
	    }
	    
	    // Route 2
	    reader = new BufferedReader(new InputStreamReader(new FileInputStream(ViaRoutesFileName2), encoding));
	    StringBuffer xml2 = new StringBuffer();
	    
	    for (String line; (line = reader.readLine()) != null;) 
		    xml2.append(line);		
	    
	    if(xml2.length() > 0) {
		RouteVia route = new RouteVia();
		route.fillDetails(xml2.toString(), null, null);
		routes.add(route);
	    }
	    
	    
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} finally {
	    try {
		reader.close();
	    } catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	    }
	}
	
	// Route[] rets = (Route[]) routes.toArray(new Route[routes.size()]);
	return routes;
    
    }
    
    public ArrayList<Route> loadAITRoutes() {
	
	BufferedReader reader = null;
	ArrayList<Route> routes = new ArrayList<Route>();
	
	try {
	    reader = new BufferedReader(new InputStreamReader(new FileInputStream(RoutesFileName), encoding));
	    StringBuffer xml = new StringBuffer();
	    
	    for (String line; (line = reader.readLine()) != null;) {
		
		if(line.contains(RouterFacade.AIT_RouteSeparator)) {
		    RouteNR route = new RouteNR();
		    route.fillDetails(xml.toString(), null, null);
		    routes.add(route);
		} else {
		    xml.append(line);
		}
	    }
	    
	    if(xml.length() > 0) {
		RouteNR route = new RouteNR();
		route.fillDetails(xml.toString(), null, null);
		routes.add(route);
	    }
	    
	    
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} finally {
	    try {
		reader.close();
	    } catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	    }
	}
	
	// Route[] rets = (Route[]) routes.toArray(new Route[routes.size()]);
	return routes;
	
    }    
    
 
    /*   
    public Geometry[] loadAITIsochroneGeometry(String isoFileName) {


	String xml = Util.getContentEnBloc("file://" + System.getProperty("user.dir") + "/"
		    + isoFileName);
	Isochrone iso = new Isochrone();
	iso.fillDetailsFromGML(xml)(xml);
	  
	return iso.getElementsAsArray();

    }
    
   
  public Geometry[] loadGenericGeometry(String strFilePath) {

	URL url = null;
	InputStream in = null;

	try {
	    url = new URL("file://" + System.getProperty("user.dir") + "/"
		    + strFilePath);
	    in = url.openStream();
	} catch (MalformedURLException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}

	GML gml = new GML(Version.GML3);
	SimpleFeatureIterator iter = null;

	try {
	    iter = gml.decodeFeatureIterator(in);
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} catch (ParserConfigurationException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} catch (SAXException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}

	ArrayList<Geometry> geos = new ArrayList<Geometry>();
	while (iter.hasNext()) {
	    SimpleFeature feature = iter.next();
	    Geometry geo = (Geometry) feature.getDefaultGeometry();
	    geos.add(geo);
	}

	Geometry[] geos2 = (Geometry[]) geos.toArray(new Geometry[geos.size()]);
	// GeometryCollection gc = new GeometryCollection(geos2,
	// geometryFactory);

	return geos2; // gc;

    }
*/
}
