package edu.tuwien.kbs.geo;

import java.io.File;
import java.io.IOException;
import java.util.UUID;

import org.apache.commons.io.FileUtils;

import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.io.gml2.GMLWriter;

public class SimpleGMLWriter {

    protected static String XML_Ver = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> \n";
    protected static String XML_L1_Open = "<wfs:FeatureCollection xmlns=\"http://www.opengis.net/wfs\" xmlns:wfs=\"http://www.opengis.net/wfs\" xmlns:gml=\"http://www.opengis.net/gml\">\n"; // "<CityModel xmlns=\"http://www.opengis.net/citygml/1.0\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:gml=\"http://www.opengis.net/gml\" xmlns:gen=\"http://www.opengis.net/citygml/generics/1.0\" xsi:schemaLocation=\"http://www.opengis.net/citygml/generics/1.0 http://schemas.opengis.net/citygml/generics/1.0/generics.xsd\"> \n";
    protected static String XML_L1_Close = "</wfs:FeatureCollection> \n"; // "</CityModel>";
    protected static String XML_L2_Open = "<gml:featureMembers>\n"; // "<cityObjectMember> \n";
    protected static String XML_L2_Close = "</gml:featureMembers>\n"; // "</cityObjectMember> \n";
    protected static String XML_L3_Open = "<gml:generic_element gml:id=\"%1$s\">\n"; // "<gen:GenericCityObject gml:id=\"%1$s\"> \n";
    protected static String XML_L3_Close = "</gml:generic_element>\n"; // "</gen:GenericCityObject> \n";

    protected static String XML_L4_Open =  "<gml:the_geom>\n"; // "<gen:lod3Geometry> <gml:MultiSurface> <gml:surfaceMember> \n";
    protected static String XML_L4_Close = "</gml:the_geom>\n"; // "</gml:surfaceMember> </gml:MultiSurface> </gen:lod3Geometry>  \n";

    
    protected static String XML_L1b_Open = "<tuw:Results \n> "; 
    protected static String XML_L1b_Close = "</tuw:Results> \n"; 
    protected static String XML_L2b_Open = "<tuw:Isochrone xmlns=\"http://www.kr.tuwien.ac.at/myits/search/1.0\" xmlns:tuw=\"http://www.kr.tuwien.ac.at/myits/search/1.0\" xmlns:gml=\"http://www.opengis.net/gml/3.2\">\n"; // "<cityObjectMember> \n";
    protected static String XML_L2b_Close = "</tuw:Isochrone>\n"; // "</cityObjectMember> \n";

    
    public SimpleGMLWriter() {

    }

    public String writeIsochrone(Geometry g) {

	StringBuffer mainXML = new StringBuffer();
	// UUID idOne = UUID.randomUUID();

	// Top Nodes
	mainXML.append(XML_Ver);
	//mainXML.append(XML_L1b_Open);
	mainXML.append(XML_L2b_Open);

	// Write Feature e.g., Point, Polygon, ...
	GMLWriter w = new GMLWriter(false);
	w.setPrefix("gml"); // http://www.kr.tuwien.ac.at/

	mainXML.append(w.write(g));

	// Close Nodes
	mainXML.append(XML_L2b_Close);
	//mainXML.append(XML_L1b_Close);

	return mainXML.toString();

    }
    
    public void writeGeometry(Geometry[] geometries, String strFilePath) { // 

	StringBuffer mainXML = new StringBuffer();
	UUID idOne = UUID.randomUUID();

	// Top Nodes
	mainXML.append(XML_Ver);
	mainXML.append(XML_L1_Open);
	mainXML.append(XML_L2_Open);

	for (int i = 0; i < geometries.length; i++) {

	    // Header
	    mainXML.append(String.format(XML_L3_Open, idOne.toString()));
	    mainXML.append(XML_L4_Open);
	    
	    // Write Feature e.g., Point, Polygon, ...
	    GMLWriter w = new GMLWriter(false);
	    w.setPrefix("gml"); // http://www.kr.tuwien.ac.at/

	    Geometry g = geometries[i];
	    mainXML.append(w.write(g));
	    
	    // Close Nodes
	    mainXML.append(XML_L4_Close);
	    mainXML.append(XML_L3_Close);

	}

	// Close Nodes
	mainXML.append(XML_L2_Close);
	mainXML.append(XML_L1_Close);

	String output = mainXML.toString();

	try {
	    FileUtils.writeStringToFile(new File(strFilePath), output);

	} catch (IOException e) {
	    // TODO Auto-generated catch block
		// TODO Auto-generated catch block
		e.printStackTrace();
	}

    }

}
