package edu.tuwien.kbs.keywords;

import edu.tuwien.kbs.util.Util;


public class SpatialPredicatesMyITS extends SpatialPredicatesBase {

    public static String KeywordQueryInside = "geot:isLocatedInside"; // "innerhalb"; "im"; "in"
    public static String KeywordQueryAlong = "geot:isLocatedAlong"; // "entlang"
    public static String KeywordQueryNext = "geot:isLocatedNext"; // "neben"; "nhe";
    public static String KeywordQueryDisjoint = "geot:isLocatedDisjoint"; // "ausserhalb";
    public static String KeywordQueryIntersect = "geot:isLocatedIntersect"; // "berschneiden";
    public static String KeywordQueryEquals = "geot:isLocatedEquals"; // "identisch";
    public static String KeywordQueryNotEquals = "geot:isLocatedNotEquals"; // "unterschiedlich";
    
    public static boolean hasSpatialPredicate(String predicate) {
        
        if(predicate.equals((KeywordQueryNext)) || predicate.equals((KeywordQueryInside)) || predicate.equals((KeywordQueryAlong)) 
    		|| predicate.equals((KeywordQueryDisjoint))  || predicate.equals((KeywordQueryIntersect))  || predicate.equals((KeywordQueryEquals)) 
    		|| predicate.equals((KeywordQueryNotEquals))  ) 
    	return true;
        else
    	return false;
    
    }

    public static String createDistanceQuery(String spatialRelation, double distanceBetween,
	    String fieldGeoA, String fieldGeoB, int geoID) {
	        
	           	if (spatialRelation.equals(SpatialPredicatesMyITS.KeywordQueryNext) || spatialRelation.equals(SpatialPredicatesMyITS.KeywordQueryAlong)) {
	        return String.format("ST_Distance_Sphere(ST_Transform(gpm.%2$s,%4$s), ST_Transform(gp2.%3$s,%4$s)) < %1$f", 
	    		Util.createObjArray(distanceBetween, fieldGeoA, fieldGeoB, geoID)); // ST_Distance       	    
	    } else if (spatialRelation.equals(SpatialPredicatesMyITS.KeywordQueryInside)) {
	        return String.format("ST_Within(ST_Transform(gpm.%1$s,%3$s), ST_Transform(gp2.%2$s,%3$s))", 
	    	    Util.createObjArray(fieldGeoA, fieldGeoB, geoID));       	
	    } else if (spatialRelation.equals(SpatialPredicatesMyITS.KeywordQueryDisjoint)) {
	        return String.format("ST_Disjoint(ST_Transform(gpm.%1$s,%3$s), ST_Transform(gp2.%2$s,%3$s))", 
	    	    Util.createObjArray(fieldGeoA, fieldGeoB, geoID));       	
	       	} else if (spatialRelation.equals(SpatialPredicatesMyITS.KeywordQueryIntersect)) {
	        return String.format("ST_Intersects(ST_Transform(gpm.%1$s,%3$s), ST_Transform(gp2.%2$s,%3$s))", 
	    	    Util.createObjArray(fieldGeoA, fieldGeoB, geoID));       	
	    } else if (spatialRelation.equals(SpatialPredicatesMyITS.KeywordQueryEquals)) {
	        return String.format("ST_Equals(ST_Transform(gpm.%1$s,%3$s), ST_Transform(gp2.%2$s,%3$s))", 
	    	    Util.createObjArray(fieldGeoA, fieldGeoB, geoID));       	
	    } else if (spatialRelation.equals(SpatialPredicatesMyITS.KeywordQueryNotEquals)) {
	        return String.format("(ST_Equals(ST_Transform(gpm.%1$s,%3$s) = False), ST_Transform(gp2.%2$s,%3$s))", 
	    	    Util.createObjArray(fieldGeoA, fieldGeoB, geoID));       	
	    } 
	           	return null;
	    
	    }   
    
	}
