package edu.tuwien.kbs.ldm;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.LineString;
import com.vividsolutions.jts.geom.Point;
import com.vividsolutions.jts.geom.Polygon;

import edu.tuwien.kbs.db.IQueryResult;
import edu.tuwien.kbs.geo.GeoUtil;
import edu.tuwien.kbs.routing.*;

/**
 * <p>
 * Title: Results of a query evaluation
 * </p>
 * <p>
 * Description:
 * </p>
 * 
 * @author Patrik Schneider
 */

public class QueryResultLDM implements IQueryResult {

    protected ArrayList<ResultLDM> mResults;// ArrayList<String[]>
    protected int mColumns;
    protected String mName;
    protected int mGeoID;    
    //protected HashMap<String, String> mExistingPois;
    
 

    public QueryResultLDM(int geoID)  {  

	mResults = new ArrayList<ResultLDM>();		
	mGeoID = geoID;
    }
    
    public int getColumns() {
	return mColumns;
    }
    
    public int getSize() {
	return mResults.size() ;
    }
    
    public ArrayList<ResultLDM>  getResults() {
	return mResults;
    }

    public void fill(ResultSet rset) throws SQLException {
	
	//mColumns = columnCount;
	HashSet<String> columns = new HashSet<String>();
	
	ResultSetMetaData rsmd = rset.getMetaData();
	int ccount = rsmd.getColumnCount();
	for (int x = 1; x <= ccount; x++) {
	    columns.add(rsmd.getColumnName(x));
	}
	
	//rset.first();
	
	// Fetch each row from the result set and move it to ArrayList
        while (rset.next()) {
            
            String idx = ""; String attx = "";  String idy = ""; String atty = "";   String idz = "";  String attz = "";
 
	    //System.out.println("Next Row");

            //String[] vars = {"a", "b", "c", "d", "e", "f", "g", "h", 
            //	    	"i", "j", "k", "l", "m", "n", "o", "p",
            //	    	"q", "r", "s", "t", "u", "v", "w"};
            
            if(columns.contains("iid_x"))
        	idx = rset.getString("iid_x");
            if(columns.contains("att_x"))
            	attx = rset.getString("att_x");
            if(columns.contains("iid_y"))
        	idy = rset.getString("iid_y");
            if(columns.contains("att_y"))
        	atty = rset.getString("att_y");
            if(columns.contains("iid_z"))
        	idz = rset.getString("iid_z");
            if(columns.contains("att_z"))
        	attz = rset.getString("att_z");
 
	    // areaoi.Area = GeoUtil.wkbToPoly(rset.getString(Postgres_Result_PosGeometry + 1));
          
            ResultLDM res = new ResultLDM(idx, attx, idy, atty, idz, attz, mGeoID);
            
            
             if(columns.contains("iid_u"))
        	res.idu = rset.getString("iid_u");
            if(columns.contains("att_u"))
        	res.attu = rset.getString("att_u");
            
            if(columns.contains("iid_v"))
        	res.idv = rset.getString("iid_v");
            if(columns.contains("att_v"))
        	res.attv = rset.getString("att_v");
            
            if(columns.contains("iid_w"))
        	res.idw = rset.getString("iid_w");
            if(columns.contains("att_w"))
        	res.attw = rset.getString("att_w");
            if(columns.contains("iid_w"))

            if(columns.contains("iid_q"))
            	res.idq = rset.getString("iid_q");
            if(columns.contains("att_q"))
            	res.attq = rset.getString("att_q");
      
            if(columns.contains("iid_r"))
        	res.idr = rset.getString("iid_r");
            if(columns.contains("att_r"))
        	res.attr = rset.getString("att_r");

            if(columns.contains("iid_s"))
        	res.ids = rset.getString("iid_s");
            if(columns.contains("att_s"))
        	res.atts = rset.getString("att_s");            

            if(columns.contains("iid_t"))
        	res.idt = rset.getString("iid_t");
            if(columns.contains("att_t"))
        	res.attt = rset.getString("att_t");            
            
            mResults.add(res);
        	
        }
    }
    

    @Override
    public void printOut(boolean silent) {

	System.out.println("Result for: " + mName);

	if (silent) {
	    // Print count
	    System.out.println("Results: " + mResults.size());
	} else {
	    for (int i = 0; i < mResults.size(); i++) {

		//FeatureOfInterest foi = (FeatureOfInterest) mResultsPoi.get(i);
		//System.out.println(foi.toString());
	    }
	}

    }

}
