package edu.tuwien.kbs.ldm;

import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.LineString;
import com.vividsolutions.jts.geom.Point;
import com.vividsolutions.jts.geom.Polygon;

import edu.tuwien.kbs.geo.GeoUtil;
import edu.tuwien.kbs.routing.FeatureOfInterest;
import edu.tuwien.kbs.routing.IFeatureOfInterest;
import edu.tuwien.kbs.routing.RouteResults;
import nu.xom.Element;

public class ResultLDM implements IFeatureOfInterest  {

    public int geoID;
    
    // Change this to hashtable
    
    public String idq ;
    public String attq ;

    public String idr ;
    public String attr ;

    public String ids ;
    public String atts ;

    public String idt ;
    public String attt ;
    
    public String idu ;
    public String attu ;
    
    public String idv ;
    public String attv ;
    
    public String idw ;
    public String attw ;    
    
    public String idx ;
    public String attx;
    
    public String idy ;
    public String atty ;
    
    public String idz ;
    public String attz ;
   
    private String fullId;
 
    
    public Point mLocPoint; // Can either be an exact point, or the center of the geometry
    public LineString mLocLine;     
    public Polygon mLocPoly;    
    
    public ResultLDM()
    {
	super();
    }
    
    public ResultLDM(String pidx, String pattx, String pidy, String patty, String pidz, String pattz, int pgeoID) 
    {
	//super();
	
	geoID = pgeoID;
	
	idx = pidx;
	attx = pattx;
	idy = pidy;
	atty = patty;
	idz = pidz;
	attz = pattz;
	
	//Location =  GeoUtil.createPoint(pointX, pointY, geoID, false);	
    }
 
    public String getID() {
	
	if(fullId==null)
	    fullId = idq + "_" + idr  + "_" + ids + "_" + idt + "_" + idu + "_" + idv + "_" + idw + "_" + idx  + "_" + idy  + "_" + idz;
	 	
	return fullId;
   }
    
    public String getAttByVar(String var) {
    
	if(var.equalsIgnoreCase("x")) {
	    return attx;
	}
	else if(var.equalsIgnoreCase("y")) {
	    return atty;
	}
	else if(var.equalsIgnoreCase("z")) {
	    return attz;
	}
	else if(var.equalsIgnoreCase("u")) {
	    return attu;
	}
	else if(var.equalsIgnoreCase("v")) {
	    return attv;
	}
	else if(var.equalsIgnoreCase("w")) {
	    return attw;
	}
	else if(var.equalsIgnoreCase("q")) {
	    return attq;
	}
	else if(var.equalsIgnoreCase("r")) {
	    return attr;
	}
	else if(var.equalsIgnoreCase("s")) {
	    return atts;
	}
	else if(var.equalsIgnoreCase("t")) {
	    return attt;
	}
	
        return null;

    }
    
    
    public void setAttByVar(String var, String value) {
	
	if(var.equalsIgnoreCase("x")) {
	    attx = value;
	}
	else if(var.equalsIgnoreCase("y")) {
	    atty = value;
	}
	else if(var.equalsIgnoreCase("z")) {
	    attz = value;
	}
	else if(var.equalsIgnoreCase("u")) {
	    attu = value;
	}
	else if(var.equalsIgnoreCase("v")) {
	    attv = value;
	}
	else if(var.equalsIgnoreCase("w")) {
	    attw = value;
	}
	else if(var.equalsIgnoreCase("q")) {
	    attq = value;
	}
	else if(var.equalsIgnoreCase("r")) {
	    attr = value;
	}
	else if(var.equalsIgnoreCase("s")) {
	    atts = value;
	}
	else if(var.equalsIgnoreCase("t")) {
	    attt = value;
	}
		    
    }   
    
    
    //public Point getPoint() {
    public Geometry getGeometry() {
	
	if(mLocPoint == null && mLocLine == null && mLocPoly == null) 
	    createPointFromAtts();
	
	if(mLocPoly != null)
	    return mLocPoly;

	if(mLocLine != null)
	    return mLocLine;
	
	if(mLocPoint != null)
	    return mLocPoint;
	
	return null;
    }
    
    public void createPointFromAtts() {
	
	if(attx!=null && (attx.contains("POINT") || attx.contains("LINESTRING") || attx.contains("POLYGON")))
	    createGEO(attx);
	if(atty!=null && (atty.contains("POINT") || atty.contains("LINESTRING") || atty.contains("POLYGON")))
	    createGEO(atty);
	if(attz!=null && (attz.contains("POINT") || attz.contains("LINESTRING") || attz.contains("POLYGON")))
	    createGEO(attz);
	if(attu!=null && (attu.contains("POINT") || attu.contains("LINESTRING") || attu.contains("POLYGON")))
	    createGEO(attu);
	if(attv!=null && (attv.contains("POINT") || attv.contains("LINESTRING") || attv.contains("POLYGON")))
	    createGEO(attv);
	if(attw!=null && (attw.contains("POINT") || attw.contains("LINESTRING") || attw.contains("POLYGON")))
	    createGEO(attw);
	if(attr!=null && (attr.contains("POINT") || attr.contains("LINESTRING") || attr.contains("POLYGON")))
	    createGEO(attr);
	
    }
    
    private void createGEO(String text) {
		
	if(text.contains("POINT"))
	    mLocPoint =  GeoUtil.wktToPoint(text);
	
	if(text.contains("LINESTRING")) {
	    if(text.contains(",")) {
		// Normal case
		mLocLine =  GeoUtil.wktToLineString(text);
	    }
	    else {
		// Special case, with a singel point
		mLocPoint =  GeoUtil.wktToPoint(text.replace("LINESTRING", "POINT"));
	    }
	    
	}
	    
	if(text.contains("POLYGON"))
	    mLocPoly =  GeoUtil.wktToPoly(text);
		
	// TODO: important
    }
    
    public Point getPoint() {
	return mLocPoint;
    }
    
    public LineString getLine() {
	return mLocLine;
    }
    
    public Polygon getPolygon() {
	return mLocPoly;
    }
    
    
}
