package edu.tuwien.kbs.ldm;

import edu.tuwien.kbs.keywords.SpatialPredicatesBase;
import edu.tuwien.kbs.util.Util;


public class SpatialPredicatesLDM extends SpatialPredicatesBase {

    public static String KeywordQueryEquals = "equals"; 
    public static String KeywordQueryDisjoint = "disjoint";
    public static String KeywordQueryTouches = "touches";
    public static String KeywordQueryContains = "contains";
    public static String KeywordQueryCovers = "covers"; 
    public static String KeywordQueryIntersects = "intersects"; 
    public static String KeywordQueryWithin = "within"; 
    public static String KeywordQueryCoveredBy = "coveredBy"; 
    public static String KeywordQueryNear = "near"; 
       
    public static boolean hasSpatialPredicate(String predicate) {
        
        if(predicate.equals((KeywordQueryEquals)) || predicate.equals((KeywordQueryDisjoint)) || predicate.equals((KeywordQueryTouches)) 
    		|| predicate.equals((KeywordQueryContains))  || predicate.equals((KeywordQueryCovers))  || predicate.equals((KeywordQueryIntersects)) 
    		|| predicate.equals((KeywordQueryWithin)) || predicate.equals((KeywordQueryCoveredBy)) || predicate.equals((KeywordQueryNear)) ) 
    	return true;
        else
    	return false;
    
    }

    public static String createDistanceQuery(String spatialRelation, double distanceBetween,
	    String fieldGeoA, String fieldGeoB, int geoID) {
	        
	    if (spatialRelation.equals(SpatialPredicatesLDM.KeywordQueryNear)) {
	        return String.format("ST_Distance_Sphere(ST_Transform(gpm.%2$s,%4$s), ST_Transform(gp2.%3$s,%4$s)) < %1$f", 
	    		Util.createObjArray(distanceBetween, fieldGeoA, fieldGeoB, geoID)); // ST_Distance       	    
	    } else if (spatialRelation.equals(SpatialPredicatesLDM.KeywordQueryWithin)) {
	        return String.format("ST_Within(ST_Transform(gpm.%1$s,%3$s), ST_Transform(gp2.%2$s,%3$s))", 
	    	    Util.createObjArray(fieldGeoA, fieldGeoB, geoID));       	
	    } else if (spatialRelation.equals(SpatialPredicatesLDM.KeywordQueryIntersects)) {
	        return String.format("ST_Intersects(ST_Transform(gpm.%1$s,%3$s), ST_Transform(gp2.%2$s,%3$s))", 
	    	    Util.createObjArray(fieldGeoA, fieldGeoB, geoID));       	
	    } else if (spatialRelation.equals(SpatialPredicatesLDM.KeywordQueryEquals)) {
	        return String.format("ST_Equals(ST_Transform(gpm.%1$s,%3$s), ST_Transform(gp2.%2$s,%3$s))", 
	    	    Util.createObjArray(fieldGeoA, fieldGeoB, geoID));       	     	
	    } 
	           	return null;
	    
	    }   
    
	}
