package edu.tuwien.kbs.ldm.parser;

import com.sun.medialib.mlib.Constants;

public class SimpleLiteralParser extends SimpleLiteralParserBase implements ILiteralParser {


	protected boolean m_IsNAFPos = true;
	protected boolean m_IsClassicalPos = true;	
	protected Predicate m_Pred;		
	
	public SimpleLiteralParser(String text) {
		super();
		m_text = text;
	}

	public ILiteral parse() {	

		m_IsNAFPos = true;
		m_IsClassicalPos = true;
		String text = m_text;
		
		text = handleNAF(text); // Handle NegAsFailure
		//text = handleClasNeg(text);	 // Handle Classical Negation
		text = handleDot(text); // Handle .
		
		// Main
		ITerm[] termObjs = null;
		int pStart = text.indexOf(Constant.PRED_OPEN);
		int pEnd = text.indexOf(Constant.PRED_CLOSE);

		// Extend with additional parameter in square brackets
		int pStartExt = text.indexOf(Constant.PRED_EXT_OPEN);
		int pEndExt = text.indexOf(Constant.PRED_EXT_CLOSE);

		if(pStart>=0 && pEnd>=0) {
			// Predicate Name
			String sPred = text.substring(0, pStart);
			termObjs = createTerms(text.substring(pStart+1, pEnd));
			
			m_Pred = new Predicate(m_IsClassicalPos, sPred, termObjs.length);


		}
		else {
			throw new RuntimeException(text + " is not recoginzed!");
		}

		// Additional parameters (for aggregation)
		if(pStartExt > 0 && pEndExt > 0) { 
		    String para = text.substring(pStartExt+1, pEndExt);
		    Literal lit =  new Literal(m_Pred, m_IsNAFPos, termObjs);
		    lit.setAddParameter(para);
		    return lit;
		}
		else {
		    return new Literal(m_Pred, m_IsNAFPos, termObjs);
		    
		}
		
	}
	
	protected String handleNAF(String inS) {
		if(inS.contains(Constant.NAF))  {
			m_IsNAFPos = false;
			return inS.substring(4); // Eliminate not			
		}
		return inS;
	}
	
	// TODO: Implement properly, this way if a - appears as constant, it fails
//	protected String handleClasNeg(String inS) {
//
//		if(inS.contains(CLAS_NEGATION))  {
//			m_IsClassicalPos = false;
//			return inS.substring(2); // Eliminate -			
//		}	
//		return inS;
//	}
	



}
