package edu.tuwien.kbs.ldm.parser;

import java.util.ArrayList;


public class SimpleRuleParser {
	
	public static final String RULE_IMPLICATION = ":-";
	public static final String LITERAL_SEPERATOR = ", ";
	public static final String RULE_PREFIX = "R";
	public static final String FACT_PREFIX = "F";
	      
	protected String m_text = null;
	
	public SimpleRuleParser() {
		//super();
	}
	
	public Rule parse(String text, int idbCount, int edbCount) { // , ArrayList <IPlugin> registeredPlugins
		Rule rle = null;

		m_text = text;

		// Rule
		if(m_text.contains(RULE_IMPLICATION)) {

		    String[] head_body = m_text.split(RULE_IMPLICATION);

		    // Head
		    ILiteralParser headParser = LiteralParserFactory.createParser(head_body[0].trim()); // , registeredPlugins
		    ILiteral litHead = headParser.parse();

		    // Body
		    String tempBody = head_body[1].trim();      		
		    String[] body =  tempBody.split(LITERAL_SEPERATOR);
		    ILiteral[] bodyLit = new ILiteral[body.length];

		    for (int j = 0; j < body.length; j++) {   			
			ILiteralParser bodyParser = LiteralParserFactory.createParser( body[j].trim()); // , registeredPlugins
			bodyLit[j] = bodyParser.parse();
		    } 


		    rle = new Rule(RULE_PREFIX + idbCount, litHead, bodyLit);

		}
		// Fact
		else {

		    // Just Head
		    ILiteralParser headParser = LiteralParserFactory.createParser(m_text); // , registeredPlugins
		    ILiteral temp = headParser.parse();
		    rle = new Rule(FACT_PREFIX + edbCount, temp, null);
		    rle.setIsFact(true);

		}

		return rle;

	}
	

}
