package edu.tuwien.kbs.routing;

import com.vividsolutions.jts.geom.*;

import edu.tuwien.kbs.geo.GeoUtil;

import nu.xom.Attribute;
import nu.xom.Element;

public abstract class FeatureOfInterest implements IFeatureOfInterest {

    public static String DefaultNamesPOI= "tuw:poi";
    public static String DefaultNamesId= "id";
    public static String DefaultNamesName= "tuw:name";
    public static String DefaultNamesDesc= "tuw:desc";
    
    public String Id;
    public String Name;
    public String Description;
 
    public int Distance;    
    public boolean RouteAssigned;

    public Point mLocPoint; // Can either be an exact point, or the center of the geometry
    //public LineString mLocLine; 
    
    public FeatureOfInterest() {
	super();
    }

    public Point getPoint() {
	return mLocPoint;
    }
    public double getPointX() {
	return mLocPoint.getX();
    }
    public double getPointY() {
	return mLocPoint.getY();
    }
    
    public LineString getLine() {
	return null;
    }
    
    public Polygon getPolygon() {
	return null;
    }
    public Geometry getGeometry() {
	return null;
    }
    
    public  Element serializeToElement(String alternateName) {
	
	Element poi = new Element(DefaultNamesPOI, RouteResults.TU_Namespace);
	
	Attribute id = new Attribute(DefaultNamesId, Id); 
	poi.addAttribute(id);
	
	Element name = new Element(DefaultNamesName, RouteResults.TU_Namespace);
	if(Name==null || Name.length() == 0) 
	    name.appendChild(alternateName);
	
	else 
	    name.appendChild(Name);
	
	poi.appendChild(name);

	if(Description != null) {
	    Element desc = new Element(DefaultNamesDesc, RouteResults.TU_Namespace);
	    desc.appendChild(Description);
	    poi.appendChild(desc);
	}

	
	Element gmlPoint = new Element("gml:Point", GeoUtil.GML_Namespace);
	poi.appendChild(gmlPoint);
	Attribute pointId = new Attribute("id", Id); // "gml:id" 
	gmlPoint.addAttribute(pointId);

	Element gmlPos = new Element("gml:pos", GeoUtil.GML_Namespace);
	String coord =  GeoUtil.pointToCoord(mLocPoint, false, ' ');
	gmlPos.appendChild(coord);
	gmlPoint.appendChild(gmlPos);

	return poi;
	
    }
    
    public String toCoord(boolean switchXY) {	
	return GeoUtil.pointToCoord(mLocPoint, switchXY, ',');
    }
    
    @Override
    public String toString() {
        return Id + "; " + Name + "; " + toCoord(false);
    }

    
}