package edu.tuwien.kbs.search;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;

public class SemSearchComments extends SemSearch {

    public static String Type_Route = "RTE";
    
    protected static String XML_Ver = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> \n";
    
    protected static String XML_L1_Open = "<tuw:comments xmlns:tuw=\"http://www.kr.tuwien.ac.at/myits/search/1.0\"> \n"; // "<cityObjectMember> \n";
    protected static String XML_L1_Close = "</tuw:comments>\n"; // "</cityObjectMember> \n";

    protected static String XML_L2_Open = "<tuw:comment>"; // "<cityObjectMember> \n";
    protected static String XML_L2_Close = "</tuw:comment>"; // "</cityObjectMember> \n";

    
    public SemSearchComments() {
	super();
	
   }


    @Override
    public String evalQuery(boolean keywords) throws Exception {
	
	// No evaluation needed
	return null;
	
    }
       
    public void setRouteComment(String userId, String sessonId,  String routeId,  String routeSectionId,  String comment) throws Exception {

	java.util.Date now = new java.util.Date();
	String dateString = new SimpleDateFormat("yyyy-MM-dd").format(now);

	// Connect and set up DB
	connectDB();
	
	Object[] args = new Object[6];
	args[0] = comment; 
	args[1] = dateString;
	args[2] = Type_Route;
	args[3] = userId;
	args[4] = routeId;
	args[5] = routeSectionId;

	String sqlUpd = String.format("UPDATE its_comment SET comment = '%1$s', creation_date = '%2$s' " +
			"WHERE type = '%3$s' AND user_id  = '%4$s' AND route_id = '%5$s' AND route_section_id = '%6$s';", args);	
	String sqlIns = String .format("INSERT INTO its_comment (type, user_id, route_id, route_section_id, comment, creation_date) " +
			"VALUES ('%3$s', '%4$s', '%5$s', '%6$s', '%1$s', '%2$s' );", args);	
	
	try {
	    
	    Statement stmt1 = mConnection.createStatement();
	    int rowcount = stmt1.executeUpdate(sqlUpd);
	    if(rowcount==0) {
		Statement stmt2 = mConnection.createStatement();
		stmt2.execute(sqlIns);
	    }
	    
	} catch (RuntimeException e) {
	    throw e;
	} catch (SQLException e) {
	    throw new RuntimeException(e.toString());
	}
	
	
	// Close and clean up DB
	closeDB(null);
   
    }

    public String getRouteComment(String userId, String sessonId,  String routeId,  String routeSectionId) throws Exception {
	
	StringBuffer mainXML = new StringBuffer();
	String result = null;
	
	// Connect and set up DB
	connectDB();

	
	Object[] args = new Object[4];
	args[0] = Type_Route;
	args[1] = userId;
	args[2] = routeId;
	args[3] = routeSectionId;
	

	String sqlSelect = String.format("SELECT comment FROM its_comment " +
		"WHERE type = '%1$s' AND user_id  = '%2$s' AND route_id = '%3$s' AND route_section_id = '%4$s';", args);	
	
	try {
	    Statement stmt = mConnection.createStatement();
	    ResultSet rset = stmt.executeQuery(sqlSelect); // .toString()

	    while (rset.next()) {
		result = rset.getString(1);
		break;
	    }
	    
	} catch (RuntimeException e) {
	    throw e;
	} catch (SQLException e) {
	    throw new RuntimeException(e.toString());
	}
	
	
	// Close and clean up DB
	closeDB(null);
 
	if(result != null) {
	    mainXML.append(XML_Ver);
	    mainXML.append(XML_L1_Open);
	    mainXML.append(XML_L2_Open);
	    mainXML.append(result);
	    mainXML.append(XML_L2_Close);
	    mainXML.append(XML_L1_Close);
	    return mainXML.toString();
	}
	
	return null;
	
    }
    
    
}
