package edu.tuwien.kbs.search;

import java.util.Map;
import java.util.Random;

import com.vividsolutions.jts.geom.*;

import edu.tuwien.kbs.db.StoreConnectionPostgreSQL;
import edu.tuwien.kbs.geo.GeoUtil;
import edu.tuwien.kbs.routing.RouteResults;

public class SemSearchDirect extends SemSearch {

    public static int Eval_Poi_Threshold = Integer.MAX_VALUE; // 105;
    public static int Result_Limit = 10; // The 10 closest should be ok for now
    public static double BUFFER_Distance_Box1 = 0.002; // 0.0015
    public static double BUFFER_Distance_Box2 = 0.02;     
    protected static String PointfileName = "input_points_VIA.rq";
 
   
    public SemSearchDirect() {
	super();
	
   }

    public SemSearchDirect(String from_to, String mots, int timeLimit, String startTime, String userId,  Map<String, String> optionsMap) {
	this();
	
	mPoints = from_to; mMots = mots; mTimeLimit = timeLimit; 
	mStartTime = startTime; mUserId = userId; mOptionsMap = optionsMap;

    
    }
	
    @Override
    public String evalQuery(boolean keywords) throws Exception {
		
	// Create Result and general id, which will be used to get for the route and iso details
	Random ranGen = new Random();
	String sessionID = Integer.toString(ranGen.nextInt(Integer.MAX_VALUE));
	
	printTime("Eval Direct Started");
	
	// Connect to DB
	mConnection = new StoreConnectionPostgreSQL( mHost, mDB, mUser, mPw);
	mConnection.connect();

	// Add schemas and optimizations
	setUpDB(true);
	
	// Read input points (can be several)
	String[] points = mPoints.split(";");
	if(points.length < 2 || points[0].length() < 2 || points[1].length() < 2) {
	    throw new Exception("Invalid input parameter: Point A and B have to be defined as --p \"p1x,p1y;p2x,p2y\" ");
	}
	// We only point A to point B
	int actualGeoID = mSchema.getDefaultInfoItem().geometryID;
	String[] psA = points[0].split("[,]"); 
	Point pointA = GeoUtil.createPoint(psA[0],psA[1], actualGeoID, true); 
	String[] psB = points[1].split("[,]"); 
	Point pointB = GeoUtil.createPoint(psB[0],psB[1], actualGeoID, true); 
	
	RouteResults routes = mRouterAccess.getDirectRoutes(sessionID, pointA, pointB, mMots, 
		    mStartTime, mTimeLimit, false, mLog, mUserId, mOptionsMap);
	printTime("Routes Calculated");
	    
	// Clean up temporary views and close connection
	mConnection.close();

	// Print results
	if (mOuputResults && mLog)  printOut(routes,false);	    

	return routes.serializeToXml(true);
	
    }
       
    protected int estimateSize() { // String[] queries
    
	// For now just return random nr
	Random randomGen = new Random();   
	return randomGen.nextInt(10);
	
	
    }
    

}
