package edu.tuwien.kbs.util;



public class QueryTemplates {

	protected String mQueryTemplate1;
	protected String mQueryTemplate2a; protected String mQueryTemplate2b;
	protected String mQueryTemplate3a; protected String mQueryTemplate3b;
	protected String mQueryTemplate4ii; protected String mQueryTemplate4oo;
	protected String mQueryTemplate4io;
	protected String mQueryTemplate5iii; protected String mQueryTemplate5ooo;
	protected String mQueryTemplate5ioo; protected String mQueryTemplate5iio;
	protected String mQueryTemplate6iiii; protected String mQueryTemplate6oooo;
	protected String mQueryTemplate6iooo; protected String mQueryTemplate6iioo; 
	protected String mQueryTemplate6iiio;
	
	public QueryTemplates()
	{ }
		
	public void load() {
	    
	    mQueryTemplate1 =  Util.getContentEnBloc("templates/query_tmpl1.rq");	    
	    mQueryTemplate2a = Util.getContentEnBloc("templates/query_tmpl2.rq");
	    mQueryTemplate2b = Util.getContentEnBloc("templates/query_tmpl2b.rq");
	    
	    mQueryTemplate3a = Util.getContentEnBloc("templates/query_tmpl3.rq");
	    mQueryTemplate3b = Util.getContentEnBloc("templates/query_tmpl3b.rq");
	    
	    mQueryTemplate4ii = Util.getContentEnBloc("templates/query_tmpl4_ii.rq");
	    mQueryTemplate4oo = Util.getContentEnBloc("templates/query_tmpl4_oo.rq");
	    mQueryTemplate4io = Util.getContentEnBloc("templates/query_tmpl4_io.rq");
	    
	    mQueryTemplate5iii = Util.getContentEnBloc("templates/query_tmpl5_iii.rq");
	    mQueryTemplate5ooo = Util.getContentEnBloc("templates/query_tmpl5_ooo.rq");
	    mQueryTemplate5ioo = Util.getContentEnBloc("templates/query_tmpl5_ioo.rq");
	    mQueryTemplate5iio = Util.getContentEnBloc("templates/query_tmpl5_iio.rq");
	    
	    mQueryTemplate6iiii = Util.getContentEnBloc("templates/query_tmpl6_iiii.rq");
	    mQueryTemplate6oooo = Util.getContentEnBloc("templates/query_tmpl6_oooo.rq");
	    mQueryTemplate6iooo = Util.getContentEnBloc("templates/query_tmpl6_iooo.rq");
	    mQueryTemplate6iioo = Util.getContentEnBloc("templates/query_tmpl6_iioo.rq");
	    mQueryTemplate6iiio = Util.getContentEnBloc("templates/query_tmpl6_iiio.rq");
	    
	}

    public String fillOneTerm(String concept) {
	return mQueryTemplate1.replace("{class}", concept);
    }

    public String fillTwoTerms(boolean objectIsIndividual, String subjConcept, String predRole, String indiv_concept) {
	if(objectIsIndividual) {
	    return mQueryTemplate2b.replace("{subj_class}", subjConcept).replace("{pred}", predRole)
		.replace("{indv}", indiv_concept);
	}
	else {
	    return mQueryTemplate2a.replace("{subj_class}", subjConcept).replace("{pred}", predRole)
		.replace("{obj_class}", indiv_concept);	
	}
    }        

    public String fillThreeTermsPred(boolean objectIsIndividual, String subjConcept, String predRole, String indiv_concept) {
	if(objectIsIndividual) {
	    return mQueryTemplate3b.replace("{subj_class}", subjConcept)
		.replace("{pred}", predRole).replace("{indv}", indiv_concept);	    
	}
	else {
	    return mQueryTemplate3a.replace("{subj_class}", subjConcept)
		.replace("{pred}", predRole).replace("{obj_class}", indiv_concept);	    
	}
    }

    public String fillThreeTermsTwoPred(boolean objIsInd1, boolean objIsInd2, 
	    String subjConcept, String indiv_concept1, String indiv_concept2, String predRole1, String predRole2) {
	
	Object[] args = new Object[5];
	args[0] = subjConcept; // At Subject it is always a concept
	args[1] = indiv_concept1;
	args[2] = indiv_concept2;
	args[3] = predRole1;
	args[4] = predRole2;

	String template;
	
	if(objIsInd1 && objIsInd2) 
	    template = mQueryTemplate4ii;
	else if(!objIsInd1 && !objIsInd2)
	    template = mQueryTemplate4oo;	    
	else 
	    template = mQueryTemplate4io;	    

	return String.format(template, args);
	
    }
    
/*    public String fillThreeTermsTwoPred(boolean objIsInd1, boolean objIsInd2, 
	    String subjConcept, String indiv_concept1, String indiv_concept2, String predRole1, String predRole2) {
	if(objIsInd1 && objIsInd2) {
	    return mQueryTemplate4ii.replace("{subj_class}", subjConcept).replace("{pred1}", predRole1).replace("{pred2}", predRole2)
		.replace("{indv1}", indiv_concept1).replace("{indv2}", indiv_concept2);	    
	}
	else if(!objIsInd1 && !objIsInd2){
	    return mQueryTemplate4oo.replace("{subj_class}", subjConcept).replace("{pred1}", predRole1).replace("{pred2}", predRole2)
		.replace("{obj_class1}", indiv_concept1).replace("{obj_class2}", indiv_concept2);	    
	}
	else {
	    return mQueryTemplate4io.replace("{subj_class}", subjConcept).replace("{pred1}", predRole1).replace("{pred2}", predRole2)
		.replace("{indv1}", indiv_concept1).replace("{obj_class2}", indiv_concept2);	    
	    
	}
    }   */

    public String fillFourTermsNoPred(boolean objIsInd1, boolean objIsInd2, boolean objIsInd3, 
	    String subjConcept, String indiv_concept1, String indiv_concept2, String indiv_concept3, 
	    String predRole1, String predRole2, String predRole3) {
	
	String template;
	int indivCount = 0;
	
	Object[] args = new Object[7];
	args[0] = subjConcept; // Subject it is always a concept
	args[1] = indiv_concept1; args[2] = indiv_concept2;
	args[3] = indiv_concept3;
	args[4] = predRole1; args[5] = predRole2;
	args[6] = predRole3;
	
	if(objIsInd1) indivCount++;
	if(objIsInd2) indivCount++;
	if(objIsInd3) indivCount++;
	
	if(indivCount==3)  template = mQueryTemplate5iii;
	else if(indivCount==2) template = mQueryTemplate5iio;
	else if(indivCount==1) template = mQueryTemplate5ioo;
	else  template = mQueryTemplate5ooo;

	return String.format(template, args);
	
    }

    public String fillFiveTermsNoPred(boolean objIsInd1, boolean objIsInd2, boolean objIsInd3, boolean objIsInd4,
	    String subjConcept, String indiv_concept1, String indiv_concept2, String indiv_concept3, String indiv_concept4,
	    String predRole1, String predRole2, String predRole3,  String predRole4) {
	
	String template;
	int indivCount = 0;
	
	Object[] args = new Object[9];
	args[0] = subjConcept; // Subject it is always a concept
	args[1] = indiv_concept1; 
	args[2] = indiv_concept2;
	args[3] = indiv_concept3; 
	args[4] = indiv_concept4;
	args[5] = predRole1; 
	args[6] = predRole2;
	args[7] = predRole3; 
	args[8] = predRole3;
	
	if(objIsInd1) indivCount++;
	if(objIsInd2) indivCount++;
	if(objIsInd3) indivCount++;
	if(objIsInd4) indivCount++;
	
	if(indivCount==4)  template = mQueryTemplate6iiii;
	else if(indivCount==3)  template = mQueryTemplate6iiio;
	else if(indivCount==2) template = mQueryTemplate6iioo;
	else if(indivCount==1) template = mQueryTemplate6iooo;
	else  template = mQueryTemplate6oooo;

	return String.format(template, args);
	
    }
    
    
}
