package edu.tuwien.kbs.util;

import java.io.*;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.*;

import org.apache.http.*;
import org.apache.http.client.*;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.*;
import org.apache.http.impl.client.DefaultHttpClient;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;


public class Util {

    public static String httpGetRequest(String host, int port, String path, List<NameValuePair> params) {

	HttpClient httpclient = new DefaultHttpClient();
	StringBuilder resultBuilder = new StringBuilder();
	
	java.net.URI uri = null;
	try {
	    uri = URIUtils.createURI("http", host, port, path, URLEncodedUtils.format(params, "UTF-8"), null); 
	} catch (URISyntaxException e1) {
	    // TODO Auto-generated catch block
	    e1.printStackTrace();
	}
	
	HttpGet httpget = new HttpGet(uri);
	HttpResponse response = null;
	
	try {
	    response = httpclient.execute(httpget);
	} catch (ClientProtocolException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}


	BufferedReader reader = null;
	try {
	    reader = new BufferedReader(new
	               InputStreamReader(response.getEntity().getContent()));
	} catch (IllegalStateException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
	 
	
	try {
	    String line = reader.readLine();
	    while (line != null) {
		resultBuilder.append(line);
		line = reader.readLine();
		   }
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
		
	return resultBuilder.toString();
    }

    public static boolean isNumeric(String str)
    {
      return str.matches("-?\\d+(.\\d+)?");
    }

    public static boolean getBoolFromArgs(String[] args, String searchKey) {

	for (int i = 0; i < args.length; i++) {
	    if (args[i].length() == 3) {
		String key = args[i].substring(2);
		if (key.equals(searchKey)) {
		    return true;
		}
	    }
	}
	
	return false;
    } 
    
    public static String getValueFromArgs(String[] args, String searchKey) {

	for (int i = 0; i < args.length; i++) {
	    if (args[i].contains("--")) {
		String key = args[i].substring(2);
		if (key.equals(searchKey)) {
		    return args[i + 1];
		}
	    }
	}
	
	return null;
    }
    
    
    public static Object[] createObjArray(Object val1, Object val2) {
	Object[] args = new Object[2];
	args[0] = val1;
	args[1] = val2;
	return args;
    }

    public static Object[] createObjArray(Object val1, Object val2, Object val3) {
	Object[] args = new Object[3];
	args[0] = val1;
	args[1] = val2;
	args[2] = val3;
	return args;
    }

    public static Object[] createObjArray(Object val1, Object val2, Object val3, Object val4) {
	Object[] args = new Object[4];
	args[0] = val1;
	args[1] = val2;
	args[2] = val3;
	args[3] = val4;
	return args;
    }

    public static Object[] createObjArray(Object val1, Object val2,
	    Object val3, Object val4, Object val5, Object val6, Object val7, Object val8) {
	Object[] args = new Object[8];
	args[0] = val1;
	args[1] = val2;
	args[2] = val3;
	args[3] = val4;
	args[4] = val5;
	args[5] = val6;
	args[6] = val7;
	args[7] = val8;
	return args;
    }
    
    public static Object[] createObjArray(Object val1, Object val2,
	    Object val3, Object val4, Object val5, Object val6, Object val7, Object val8, Object val9) {
	Object[] args = new Object[9];
	args[0] = val1;
	args[1] = val2;
	args[2] = val3;
	args[3] = val4;
	args[4] = val5;
	args[5] = val6;
	args[6] = val7;
	args[7] = val8;
	args[8] = val9;
	return args;
    }

    static public String getContentEnBloc(String fileName) {

	StringBuffer result = new StringBuffer();

	// declared here only to make visible to finally clause
	BufferedReader input = null;

	File aFile = new File(fileName);

	try {

	    // use buffering, reading one line at a time
	    input = new BufferedReader(new FileReader(aFile));
	    String line = null;

	    while ((line = input.readLine()) != null) {
		result.append(line);
		result.append(" \n");
	    }
	} catch (FileNotFoundException ex) {
	    ex.printStackTrace();
	} catch (IOException ex) {
	    ex.printStackTrace();
	} finally {
	    try {
		if (input != null) {
		    // flush and close both "input" and its underlying
		    // FileReader
		    input.close();
		}
	    } catch (IOException ex) {
		ex.printStackTrace();
	    }
	}

	return result.toString();
    }

    static public Document getXMLDomFromString(String xml) {

	Document doc = null;

	try {
	    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
	    DocumentBuilder db = dbf.newDocumentBuilder();
	    doc = db.parse(xml);
	    // doc.getDocumentElement().normalize();

	} catch (SAXException ex) {
	    ex.printStackTrace();
	}

	catch (FileNotFoundException ex) {
	    ex.printStackTrace();
	} catch (IOException ex) {
	    ex.printStackTrace();
	} catch (ParserConfigurationException ex) {
	    ex.printStackTrace();
	}
	return doc;

    }

    static public Document getXMLDomFromFile(String fileName) {

	File file = new File(fileName);
	Document doc = null;

	try {
	    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
	    DocumentBuilder db = dbf.newDocumentBuilder();
	    doc = db.parse(file);
	    doc.getDocumentElement().normalize();

	} catch (SAXException ex) {
	    ex.printStackTrace();
	}

	catch (FileNotFoundException ex) {
	    ex.printStackTrace();
	} catch (IOException ex) {
	    ex.printStackTrace();
	} catch (ParserConfigurationException ex) {
	    ex.printStackTrace();
	}
	return doc;

    }


    /**
     * Taken from http://www.javapractices.com Change the contents of text file
     * in its entirety, overwriting any existing text.
     * 
     * This style of implementation throws all exceptions to the caller.
     * 
     * @param aFile
     *            is an existing file which can be written to.
     * @throws IllegalArgumentException
     *             if param does not comply.
     * @throws FileNotFoundException
     *             if the file does not exist.
     * @throws IOException
     *             if problem encountered during write.
     */
    static public void setContents(String fileName, String aContents)
	    throws FileNotFoundException, IOException {

	File aFile = new File(fileName);

	Writer writer = null;

	try {
	    writer = new BufferedWriter(new FileWriter(aFile));
	    writer.write(aContents);
	} catch (FileNotFoundException e) {
	    e.printStackTrace();
	} catch (IOException e) {
	    e.printStackTrace();
	} finally {
	    try {
		if (writer != null) {
		    writer.close();
		}
	    } catch (IOException e) {
		e.printStackTrace();
	    }
	}
    }

    /**
     * Taken from http://www.javapractices.com
     * 
     * Fetch the entire contents of a text file, and return it in a String. This
     * style of implementation does not throw Exceptions to the caller.
     * 
     * @param aFile
     *            is a file which already exists and can be read.
     */
    static public String[] getContent(String fileName) {

	ArrayList<String> lines = new ArrayList<String>(1000);

	// declared here only to make visible to finally clause
	BufferedReader input = null;

	File aFile = new File(fileName);

	try {

	    // use buffering, reading one line at a time
	    input = new BufferedReader(new FileReader(aFile));
	    String line = null;

	    while ((line = input.readLine()) != null) {
		lines.add(line);

	    }
	} catch (FileNotFoundException ex) {
	    ex.printStackTrace();
	} catch (IOException ex) {
	    ex.printStackTrace();
	} finally {
	    try {
		if (input != null) {
		    // flush and close both "input" and its underlying
		    // FileReader
		    input.close();
		}
	    } catch (IOException ex) {
		ex.printStackTrace();
	    }
	}

	return lines.toArray(new String[0]);
    }

}
